<?php

class Login_Controller extends AbstractController
{
	function index() { $this->login(); }

	function login()
	{
		$username = Url::get('username');
		$password = md5(Url::get('password'));
		$redirect = Url::get('redirect');
		$json = Url::getBool('json');

		//
		// process login.

		// logout user if already logged in (we will login with new credentials).
		/*if ($this->user->isLoggedIn()) {
			trigger_error('Already logged in to ' . $this->user->username());
			return;
		}*/

		// login user using information given
		$login_success = $this->user->login($username, $password);

		if ($json) {
			// return JSON object with relevant information
			$userinfo = $login_success ? $this->user->getArray() : null;
			$result = array(
				'login_success' => $login_success,
				'json' => $json,
				'form_username' => $username,
				'form_password' => $password,
				'userinfo' => $userinfo,
			);

			echo json_encode($result);
		} else if ($redirect) {
			// redirect to given url.
			Url::redirect($redirect);
		} else {
			// do nothing if json and redirect not specified.
			die('Debug: Did nothing (redirect and json empty)');
		}
	}

	function logout()
	{
		$redirect = Url::get('redirect');

		// logout the user
		if ($this->user->isLoggedIn()) {
			$this->user->logout();
		}

		if ($redirect) {
			// redirect to given url.
			Url::redirect($redirect);
		} else {
			// redirect to default controller if no redirect specified.
			include(TMVC_MYAPPDIR . 'configs' . DS . 'application.php');
			Url::redirect(Url::create($config['default_controller']));
		}
	}
}

?>