<?php

class Favorites_Model extends AbstractModel
{
	function getSavedFoods($userId)
	{
		$foods = $this->db->queryColumn('select favoriteFood from usersavedfood where userId = ?', array($userId));
		return $foods;
	}

	function getSavedRecipeIds($userId)
	{
		$recipeIds = $this->db->queryColumn('
			select recipeId
			from usersavedrecipe
			where userId = ?', array($userId));

		return $recipeIds;
	}

	function getSavedRecipes($userId, &$recipeModel)
	{
		$recipeIds = $this->getSavedRecipeIds($userId);

		$result = array();
		foreach ($recipeIds as $recipeId) {
			$result[] = $recipeModel->getRecipeById($recipeId);
		}

		return $result;
	}

	function getSavedSpecialIds($userId)
	{
		$specialIds = $this->db->queryColumn('
			select specialId
			from usersavedspecial
			where userId = ?', array($userId));

		return $specialIds;
	}

	function getSavedSpecials($userId, $specialModel)
	{
		$specialIds = $this->getSavedSpecialIds($userId);

		$result = array();
		foreach ($specialIds as $specialId) {
			$result[] = $specialModel->getSpecialById($specialId);
		}

		return $result;
	}

	function addFood($userId, $food)
	{
		if (!array_search($food, $this->getSavedFoods($userId))) {
			$this->db->query('insert into usersavedfood (userId, favoriteFood) values(?, ?)', array($userId, $food));
			return $this->db->lastInsertId();
		} else {
			return false;
		}
	}

	function addRecipe($userId, $recipeId)
	{
		if (!array_search($recipeId, $this->getSavedRecipeIds($userId))) {
			$this->db->query('insert into usersavedrecipe (userId, recipeId) values(?, ?)', array($userId, $recipeId));
			return $this->db->lastInsertId();
		} else {
			return false;
		}
	}

	function addSpecial($userId, $specialId)
	{
		if (!array_search($specialId, $this->getSavedSpecialIds($userId))) {
			$this->db->query('insert into usersavedspecial (userId, specialId) values(?, ?)', array($userId, $specialId));
			// die(print_r($this->db->pdo->errorInfo(), false));
			return $this->db->lastInsertId();
		} else {
			return false;
		}
	}

	function removeFood($userId, $food)
	{
		$this->db->query('delete from usersavedfood where userId = ? and favoriteFood = ?',
			array($userId, $food)
		);
	}

	function removeRecipe($userId, $recipeId)
	{
		$this->db->query('delete from usersavedrecipe where userId = ? and recipeId = ?',
			array($userId, $recipeId)
		);
	}

	function removeSpecial($userId, $specialId)
	{
		$this->db->query('delete from usersavedspecial where userId = ? and specialId = ?',
			array($userId, $specialId)
		);
	}
}

?>