<?php

// require the Smarty class
require(TMVC_BASEDIR . '..' . DS . '/smarty/libs/Smarty.class.php');

class Smarty_Wrapper extends Smarty
{
	function __construct()
	{
		parent::Smarty();

		$base = TMVC_BASEDIR . '..' . DS;
		$this->compile_dir = $base . '/smarty/templates_c/';
		$this->config_dir = $base . '/smarty/configs/';
		$this->cache_dir = $base . '/smarty/cache/';

		// we will use our view directory for template files
		$this->template_dir = TMVC_MYAPPDIR . 'views/';
		
		// disable caching so that we don't have to worry about template_c permissions.
		// uncomment to disable caching:
		// $this->caching = 0;

		// register custom smarty functions
		$this->register_function('csurl', 'smarty_function_csurl');
	}
}

function smarty_function_csurl($params, &$smarty)
{
	if (!isset($params['page'])) {
		trigger_error('Smarty csurl function requires parameter "page".', E_USER_NOTICE);
		return '';
	}

	$page = $params['page']; // required
	$action = null;
	$get_args = array();
	$other = array();
	
	foreach ($params as $key => $param) {
		switch($key) {
			case 'page':
				$page = $param;
				break;
			case 'action':
				$action = $param;
				break;
			case 'get_args';
				$get_args = $param;
				break;
			default:
				$other[$key] = $param;
				break;
		}
	}
	
	return Url::create($page, $action, array_merge($get_args, $other));
}

?>