<?php

/* A collection of classes designed to encapsulate objects like Recipes, Specials, RecipeIngredients */

class ArrayClass {
	private $data;
	protected function data() { return $this->data; }
	protected function setData($data) { $this->data = $data; }

	public static function createArray($rows)
	{
		$result = array();
		foreach ($rows as $row) {
			$result[] = new ArrayClass($row);
		}
		return $result;
	}

	public function __construct($row)
	{
		$this->setData($row);
	}

	public function __get($var)
	{
		if (array_key_exists($var, $this->data)) {
			return $this->data[$var];
		} else {
			return null;
		}
	}

	public function __isset($var)
	{
		return array_key_exists($var, $this->data) && isset($this->data[$var]);
	}

	public function toArray() { return $this->data(); }
}

class Recipe extends ArrayClass {}
class RecipeIngredient extends ArrayClass {}
class Special extends ArrayClass {}


?>